local skynet = require "skynet"
require "skynet.manager"
local spawn = require "model.spawn"
local skynet_call = skynet.call
local module = {
}

local usercenter
local function loader(uid)
  assert(uid)
  usercenter = usercenter or skynet.localname(".usercenter")

  local rets = skynet_call(usercenter, "lua", "load", uid)
  local t = spawn(true).loadfrom(rets)
  for _, elem in ipairs(module) do
    if elem.parse then
      elem.parse(t)
    end
  end
  return t
end

return loader