local skynet = require "skynet"
local httpc = require "http.httpc"
local logger = require "logger"
local cjson = require "cjson"
local stringify = require "stringify"
local md5 = require "md5"
require "skynet.manager"

local trace = logger.trace
local cjson_decode = cjson.decode

local conf = {
  ["gameloft_infinite"] = { appkey = "h0DKUEW9GFHvUy4q"},    -- 智乐互娱-安卓/IOS
  ["xiaohei"] = {}
}

local tourist = {}
function tourist.login_player(args)
    local channel = args.channel
    local tconf = conf[channel]
    if tconf then
      local account = args.account
      local appkey = tconf.appkey
      local token = args.token
      local mytoken = md5.sumhexa(account..appkey)
      local ok = mytoken == token

      if ok then
          return 0
      else
          logger.trace("游客登录验证失败 account:%s, appkey:%s, token:%s, mytoken:%s",account, appkey, token, mytoken)
          return
      end
    end
end

return tourist